% Opening function automatically generated by GUIDE
function varargout = plot_gui(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @plot_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @plot_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% --- Executes on button press in refresh_but.
% Populates the drop-down list with available serial ports.
function refresh_but_Callback(hObject, eventdata, handles)
serialInfo = instrhwinfo('serial');
handles.port_list.String = serialInfo.AvailableSerialPorts;

% --- Port list initial conditions
function port_list_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in connect_but.
function connect_but_Callback(hObject, eventdata, handles)

% Close any existing connection formed by MATLAB
inst = instrfind;
isOpen = @(x) strcmp(x, 'open');
if ~isempty(inst)
    if iscell(inst)
    toClose = inst(cellfun(isOpen, inst.Status));
    else
        toClose = inst(isOpen(inst.Status));
    end
    for i = 1:length(toClose)
       fclose(toClose(i)); 
    end
end

% Establish connection to the DVF
s = serial(handles.port_list.String{handles.port_list.Value});
s.BaudRate = 115200;
fopen(s);
handles.fig.UserData.serial = s;

% --- Executes on button press in x_check.
function x_check_Callback(hObject, eventdata, handles)

% --- Executes on button press in y_check.
function y_check_Callback(hObject, eventdata, handles)

function port_list_Callback(hObject, eventdata, handles)

% --- Executes on button press in clear_x_but.
function clear_x_but_Callback(hObject, eventdata, handles)
cla(handles.x_mag);
cla(handles.x_phs);

% --- Executes on button press in clear_y_but.
function clear_y_but_Callback(hObject, eventdata, handles)
cla(handles.y_mag);
cla(handles.y_phs);
